Index: configure
===================================================================
--- configure	(revision 1230)
+++ configure	(revision 1232)
@@ -487,4 +487,5 @@
 test_tool_defmake ROAR_HAVE_BIN_GNUPLOT    gnuplot      gnuplot
 test_tool_defmake ROAR_HAVE_BIN_SSH        OpenSSH      ssh
+test_tool_defmake ROAR_HAVE_BIN_PINENTRY   PIN-Entry    pinentry
 
 echo >&3
Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 1075)
+++ include/libroar/libroar.h	(revision 1232)
@@ -73,4 +73,5 @@
 #include "file.h"
 #include "acl.h"
+#include "pinentry.h"
 
 #endif
Index: include/libroar/pinentry.h
===================================================================
--- include/libroar/pinentry.h	(revision 1232)
+++ include/libroar/pinentry.h	(revision 1232)
@@ -0,0 +1,62 @@
+//pinentry.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *
+ *  This file is part of libroar a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroar is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this lib
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
+
+#ifndef _LIBROAR_PINENTRY_H_
+#define _LIBROAR_PINENTRY_H_
+
+#include "libroar.h"
+
+//pinentry.h
+
+struct roar_pinentry {
+ int open;
+ pid_t pid;
+ int in;
+ int out;
+};
+
+int roar_pinentry_open (struct roar_pinentry * pe, int flags, char * display, char * tty, char * term);
+int roar_pinentry_simple_open(struct roar_pinentry * pe);
+int roar_pinentry_close(struct roar_pinentry * pe);
+
+int roar_pinentry_send (struct roar_pinentry * pe, char * cmd,  char * args);
+int roar_pinentry_recv (struct roar_pinentry * pe, char * line, char * opts);
+int roar_pinentry_req  (struct roar_pinentry * pe, char * cmd,  char * args, char * line, char * opts);
+
+int roar_pinentry_set_desc (struct roar_pinentry * pe, char * desc);
+int roar_pinentry_set      (struct roar_pinentry * pe, char * obj, char * text);
+
+#endif
+
+//ll
Index: libroar/Makefile
===================================================================
--- libroar/Makefile	(revision 1179)
+++ libroar/Makefile	(revision 1232)
@@ -2,5 +2,5 @@
 
 TARGETS=libroar.so
-OBJS=libroar.o basic.o stream.o simple.o auth.o socket.o ctl.o buffer.o convert.o poly.o meta.o file.o acl.o vio.o cdrom.o
+OBJS=libroar.o basic.o stream.o simple.o auth.o socket.o ctl.o buffer.o convert.o poly.o meta.o file.o acl.o vio.o cdrom.o pinentry.o
 
 #DEFINES        = -DDEBUG
Index: libroar/pinentry.c
===================================================================
--- libroar/pinentry.c	(revision 1232)
+++ libroar/pinentry.c	(revision 1232)
@@ -0,0 +1,37 @@
+//pinentry.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *
+ *  This file is part of libroar a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroar is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this lib
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
+
+#include "libroar.h"
+
+//ll