Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 1280)
+++ include/libroar/libroar.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/stack.h
===================================================================
--- include/libroar/stack.h	(revision 1282)
+++ include/libroar/stack.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio.h
===================================================================
--- include/libroar/vio.h	(revision 1275)
+++ include/libroar/vio.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_cmd.h
===================================================================
--- include/libroar/vio_cmd.h	(revision 1273)
+++ include/libroar/vio_cmd.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_magic.h
===================================================================
--- include/libroar/vio_magic.h	(revision 1274)
+++ include/libroar/vio_magic.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_ops.h
===================================================================
--- include/libroar/vio_ops.h	(revision 1277)
+++ include/libroar/vio_ops.h	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroar/stack.c
===================================================================
--- libroar/stack.c	(revision 1282)
+++ libroar/stack.c	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroar/vio.c
===================================================================
--- libroar/vio.c	(revision 1275)
+++ libroar/vio.c	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroar/vio_cmd.c
===================================================================
--- libroar/vio_cmd.c	(revision 1278)
+++ libroar/vio_cmd.c	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroar/vio_magic.c
===================================================================
--- libroar/vio_magic.c	(revision 1276)
+++ libroar/vio_magic.c	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroar/vio_ops.c
===================================================================
--- libroar/vio_ops.c	(revision 1277)
+++ libroar/vio_ops.c	(revision 1284)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
  *
  *  This file is part of libroar a part of RoarAudio,