Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 1284)
+++ include/libroar/libroar.h	(revision 1288)
@@ -80,4 +80,5 @@
 #include "acl.h"
 #include "pinentry.h"
+#include "sshaskpass.h"
 
 #endif
Index: include/libroar/sshaskpass.h
===================================================================
--- include/libroar/sshaskpass.h	(revision 1288)
+++ include/libroar/sshaskpass.h	(revision 1288)
@@ -0,0 +1,44 @@
+//sshaskpass.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *
+ *  This file is part of libroar a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroar is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this lib
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
+
+#ifndef _LIBROAR_SSHASKPASS_H_
+#define _LIBROAR_SSHASKPASS_H_
+
+#include "libroar.h"
+
+int roar_sshaskpass_getpass   (char ** pw, char * desc);
+
+#endif
+
+//ll
Index: libroar/Makefile
===================================================================
--- libroar/Makefile	(revision 1280)
+++ libroar/Makefile	(revision 1288)
@@ -3,5 +3,5 @@
 TARGETS=libroar.so
 VIO=vio.o vio_cmd.o vio_ops.o vio_magic.o
-OBJS=libroar.o basic.o stream.o simple.o auth.o socket.o ctl.o buffer.o convert.o poly.o meta.o file.o acl.o cdrom.o pinentry.o $(VIO) stack.o
+OBJS=libroar.o basic.o stream.o simple.o auth.o socket.o ctl.o buffer.o convert.o poly.o meta.o file.o acl.o cdrom.o pinentry.o sshaskpass.o $(VIO) stack.o
 
 #DEFINES        = -DDEBUG
Index: libroar/sshaskpass.c
===================================================================
--- libroar/sshaskpass.c	(revision 1288)
+++ libroar/sshaskpass.c	(revision 1288)
@@ -0,0 +1,51 @@
+//sshaskpass.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *
+ *  This file is part of libroar a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  libroar is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  NOTE for everyone want's to change something and send patches:
+ *  read README and HACKING! There a addition information on
+ *  the license of this document you need to read before you send
+ *  any patches.
+ *
+ *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
+ *  or libpulse*:
+ *  The libs libroaresd, libroararts and libroarpulse link this lib
+ *  and are therefore GPL. Because of this it may be illigal to use
+ *  them with any software that uses libesd, libartsc or libpulse*.
+ */
+
+#include "libroar.h"
+
+int roar_sshaskpass_getpass   (char ** pw, char * desc) {
+#ifdef ROAR_HAVE_BIN_SSH_ASKPASS
+ FILE * pipe;
+
+ if ( (pipe = popen(ROAR_HAVE_BIN_SSH_ASKPASS, "r")) == NULL ) {
+  return -1;
+ }
+
+ fclose(pipe);
+#else
+ return -1;
+#endif
+}
+
+//ll