Index: ChangeLog
===================================================================
--- ChangeLog	(revision 5957)
+++ ChangeLog	(revision 5958)
@@ -8,4 +8,5 @@
 	  support using libRAUM got disabled (See #233).
 	* Added support for setting a default device for roard at compile time.
+	* Removed OpenSSL support (See: #366)
 
 v. 1.0beta10 - Tue Oct 15 2013 12:03 CEST
Index: configure
===================================================================
--- configure	(revision 5957)
+++ configure	(revision 5958)
@@ -92,5 +92,4 @@
 
 # Libs which are per default disabled:
-no_lib_ssl=true
 no_lib_gcrypt=true
 
@@ -725,5 +724,4 @@
 test_lib_defmake ROAR_HAVE_LIBPORTAUDIO  %            PortAudio     portaudio  -- portaudio.h
 test_lib_defmake ROAR_HAVE_LIBPABLIO     %            PABLIO        pablio     -- pablio/pablio.h
-test_lib_defmake ROAR_HAVE_LIBSSL        %            OpenSSL       ssl        -- openssl/bio.h openssl/evp.h
 test_lib_defmake ROAR_HAVE_LIBSLP        %            OpenSLP       slp        -- slp.h
 test_lib_defmake ROAR_HAVE_LIBDNET       %            libdnet       dnet       -- sys/socket.h netdnet/dn.h netdnet/dnetdb.h
Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 5951)
+++ include/libroar/libroar.h	(revision 5958)
@@ -109,11 +109,4 @@
 #if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER)
 #include <netdb.h>
-#endif
-
-// OpenSSL (crypto):
-
-#ifdef ROAR_HAVE_LIBSSL
-#include <openssl/bio.h>
-#include <openssl/evp.h>
 #endif
 
Index: include/libroar/vio_bio.h
===================================================================
--- include/libroar/vio_bio.h	(revision 5823)
+++ include/libroar/vio_bio.h	(revision 5958)
@@ -39,17 +39,6 @@
 #include "libroar.h"
 
-#ifdef ROAR_HAVE_LIBSSL
-int     roar_vio_open_bio      (struct roar_vio_calls * calls, BIO * bio);
-BIO *   roar_vio_to_bio        (struct roar_vio_calls * calls);
-
-ssize_t roar_vio_bio_read    (struct roar_vio_calls * vio, void *buf, size_t count);
-ssize_t roar_vio_bio_write   (struct roar_vio_calls * vio, void *buf, size_t count);
-roar_off_t   roar_vio_bio_lseek   (struct roar_vio_calls * vio, roar_off_t offset, int whence);
-int     roar_vio_bio_sync    (struct roar_vio_calls * vio);
-int     roar_vio_bio_close   (struct roar_vio_calls * vio);
-#else
 int     roar_vio_open_bio      (struct roar_vio_calls * calls, void * bio);
 void *  roar_vio_to_bio        (struct roar_vio_calls * calls);
-#endif
 
 #endif
Index: libroar/vio_bio.c
===================================================================
--- libroar/vio_bio.c	(revision 5823)
+++ libroar/vio_bio.c	(revision 5958)
@@ -36,69 +36,4 @@
 #include "libroar.h"
 
-#ifdef ROAR_HAVE_LIBSSL
-int     roar_vio_open_bio      (struct roar_vio_calls * calls, BIO * bio) {
- if ( calls == NULL || bio == NULL )
-  return -1;
-
- memset(calls, 0, sizeof(struct roar_vio_calls));
- calls->flags    = ROAR_VIO_FLAGS_NONE;
- calls->refc     = 1;
-
- calls->read     = roar_vio_bio_read;
- calls->write    = roar_vio_bio_write;
- calls->lseek    = roar_vio_bio_lseek;
- calls->sync     = roar_vio_bio_sync;
- calls->close    = roar_vio_bio_close;
-
- calls->inst     = (void*) bio;
-
- return 0;
-}
-
-BIO *   roar_vio_to_bio        (struct roar_vio_calls * calls) {
- roar_err_set(ROAR_ERROR_NOSYS);
- return NULL;
-}
-
-ssize_t roar_vio_bio_read    (struct roar_vio_calls * vio, void *buf, size_t count) {
- BIO * bio = (BIO*)(vio->inst);
- int r;
-
- if ( (r = BIO_read(bio, buf, count)) == -2 )
-  return -1;
-
- return r;
-}
-ssize_t roar_vio_bio_write   (struct roar_vio_calls * vio, void *buf, size_t count) {
- BIO * bio = (BIO*)(vio->inst);
- int r;
-
- if ( (r = BIO_write(bio, buf, count)) == -2 )
-  return -1;
-
- return r;
-}
-
-roar_off_t   roar_vio_bio_lseek   (struct roar_vio_calls * vio, roar_off_t offset, int whence) {
- return -1;
-}
-
-int     roar_vio_bio_sync    (struct roar_vio_calls * vio) {
- return -1;
-}
-
-int     roar_vio_bio_close   (struct roar_vio_calls * vio) {
- BIO * bio = (BIO*)(vio->inst);
-
- // TODO: check the return values
-
- BIO_flush(bio);
- BIO_free_all(bio);
-
- return 0;
-}
-#endif
-
-#ifndef ROAR_HAVE_LIBSSL
 int     roar_vio_open_bio      (struct roar_vio_calls * calls, void * bio) {
  (void)calls, (void)bio;
@@ -108,8 +43,8 @@
 
 void *  roar_vio_to_bio        (struct roar_vio_calls * calls) {
+ (void)calls;
  roar_err_set(ROAR_ERROR_NOSYS);
  return NULL;
 }
-#endif
 
 //ll